import { requestClient } from '#/api/request';

export namespace RoleApi {
  export interface Role {
    name: string;
    dataScope: string;
    permissionIds: (number | undefined)[];
    remark: string;
    authorities: (number | undefined)[];
    id?: string;
  }

  // 基础信息
  export interface RoleRecord extends Role {
    id: string;
  }

  export interface RoleListRecord extends RoleRecord {
    name: string;
  }
}

// 查询所有的角色列表、
export function queryRoleList(data: any) {
  // return axios.get('/api/rest/role',data);
  return requestClient.get('/api/rest/role', { data });
}

// 切换启用状态
export function enabled(id: string) {
  return requestClient.patch(`/api/rest/role/${id}/toggle`);
}

// 删除
export function removeRole(id: string) {
  return requestClient.delete(`/api/rest/role/${id}`);
}

// 添加
export function createRole(data: RoleApi.Role) {
  return requestClient.post(`/api/rest/role`, data);
}

// 更新
export function updateRole(data: RoleApi.RoleRecord) {
  return requestClient.patch(`/api/rest/role/${data.id}`, data);
}

// 获取详情
export function getDetail(id: string) {
  return requestClient.get<RoleApi.RoleRecord>(`/api/rest/role/${id}`);
}

// export function queryRoles(params?: ListParams<Partial<RoleRecord>>) {
//   return queryList<RoleRecord>(`/api/rest/role/query`, params);
// }
